## alkimia 8.1.2

=== CMakeLists.txt ===
# The CMake version we require (must be first)
cmake_minimum_required(VERSION 3.16.0)
if(POLICY CMP0071)
    cmake_policy(SET CMP0071 NEW)
endif()

project(alkimia VERSION 8.1.2)

option(BUILD_QT4 "Build for Qt4" OFF)
option(BUILD_DOXYGEN_DOCS "Build api docs" ON)
option(BUILD_TOOLS "Build tools" ON)
option(BUILD_WITH_QTNETWORK "Build with Qt Network library for downloading" WIN32)
option(BUILD_WITH_WEBKIT "Build with Qt Web Kit library" OFF)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(ENABLE_CLIENT_PACKAGE_TEST "enable test for building a client package" OFF)

# No Plasma on Windows, so no applets
include(CMakeDependentOption)
cmake_dependent_option(BUILD_APPLETS "Build plasma applets" ON "NOT WIN32" OFF)

if(WIN32)
    set(ENABLE_FINANCEQUOTE_DEFAULT 0)
else()
    set(ENABLE_FINANCEQUOTE_DEFAULT 1)
endif()
option(ENABLE_FINANCEQUOTE "Enable finance quote support (requires perl)" ENABLE_FINANCEQUOTE_DEFAULT)
if(ENABLE_FINANCEQUOTE)
    add_definitions(-DENABLE_FINANCEQUOTE)
    set(PACKAGE_COMPILE_OPTIONS "-DHAVE_ALK_FINANCEQUOTE")
endif()

find_package(ECM 0.0.11 REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
include(Macros)

include(ECMAddAppIcon)
include(ECMInstallIcons)
include(KDEInstallDirs)
# disable KDE provided appstreamtest which does not have required DESTDIR support
set(KDE_SKIP_TEST_SETTINGS TRUE)
if(NOT BUILD_QT4)
    option(BUILD_TESTING "Build the testing tree." ON)
    if(BUILD_TESTING)
         enable_testing()
    endif()
endif()
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)

# check for PkgConfig, Qt and MPIR/GMP
find_package(PkgConfig)
if(BUILD_QT4)
    set(QT_USE_LIBSPREFIX Qt4::Qt)
    set(ALKIMIA_LIB_SUFFIX "")
    set(ALKIMIA_INCLUDE_SUFFIX "Qt4")
    set(ALKIMIA_PATH_SUFFIX)
    set(PC_TARGET_QTPREFIX Qt)
    set(PC_TARGET_SUFFIX)

    if(BUILD_WITH_WEBKIT)
        add_definitions(-DBUILD_WITH_WEBKIT)
        set(QT_BROWSER_COMPONENT QtWebKit)
        set(QT_BROWSER_LIB ${QT_USE_LIBSPREFIX}WebKit)
        feature_notes(TRUE TRUE TRUE TRUE)
    else()
        feature_notes(FALSE TRUE FALSE FALSE)
    endif()

    if(BUILD_WITH_QTNETWORK)
        add_definitions(-DBUILD_WITH_QTNETWORK)
        set(QT_NETWORK_COMPONENT QtNetwork)
        set(QT_NETWORK_LIB ${QT_USE_LIBSPREFIX}Network)
    else()
        set(QT_NETWORK_COMPONENT)
    endif()

    find_package(Qt4 REQUIRED COMPONENTS QtCore QtGui QtDBus ${QT_NETWORK_COMPONENT} QtTest ${QT_BROWSER_COMPONENT} QtDeclarative)
    set(_kde4_uninstall_rule_created 1)
    find_package(KDE4 REQUIRED)
    if(NOT BUILD_WITH_QTNETWORK)
        set(KDE_NETWORK_LIBS ${KDE4_KIO_LIBS})
    endif()
    include(KDE4Defaults)
    include_directories(${KDE4_INCLUDES})
    macro(ki18n_wrap_ui)
        kde4_add_ui_files(${ARGN})
    endmacro(ki18n_wrap_ui)
    macro(kconfig_add_kcfg_files)
        kde4_add_kcfg_files(${ARGN})
    endmacro(kconfig_add_kcfg_files)
    macro(ecm_add_executable)
        kde4_add_executable(${ARGN})
    endmacro(ecm_add_executable)

    macro(ecm_mark_nongui_executable)
        foreach(_target ${ARGN})
            set_target_properties(${_target}
                                  PROPERTIES
                                  WIN32_EXECUTABLE FALSE
                                  MACOSX_BUNDLE FALSE
                                 )
        endforeach()
    endmacro(ecm_mark_nongui_executable)

    macro(ecm_install_icons)
        kde4_install_icons(${ICON_INSTALL_DIR})
    endmacro()

    add_definitions(-DQStringLiteral=QLatin1String)
    if(NOT SHARE_INSTALL_DIR)
        set(SHARE_INSTALL_DIR ${DATA_INSTALL_DIR})
    endif()
else()
    set(QT_USE_LIBSPREFIX Qt5::)
    set(ALKIMIA_LIB_SUFFIX "5")
    set(ALKIMIA_INCLUDE_SUFFIX "Qt5")
    set(ALKIMIA_PATH_SUFFIX 5)
    set(PC_TARGET_QTPREFIX Qt5)
    set(PC_TARGET_SUFFIX 5)

    find_package(Qt5WebEngineWidgets 5.9.3)

    option(BUILD_WITH_WEBENGINE "Build with Qt Web Engine (experimental)" ${Qt5WebEngineWidgets_FOUND})
    if (BUILD_WITH_WEBENGINE)
        add_definitions(-DBUILD_WITH_WEBENGINE)
        set(QT_BROWSER_COMPONENT WebEngineWidgets)
        feature_notes(FALSE TRUE FALSE FALSE)
    elseif(BUILD_WITH_WEBKIT)
        add_definitions(-DBUILD_WITH_WEBKIT)
        set(QT_BROWSER_COMPONENT WebKitWidgets)
        feature_notes(TRUE TRUE TRUE TRUE)
    else()
        set(QT_BROWSER_COMPONENT Widgets)
        feature_notes(FALSE TRUE FALSE FALSE)
    endif()
    set(QT_BROWSER_LIB ${QT_USE_LIBSPREFIX}${QT_BROWSER_COMPONENT})
    if(BUILD_WITH_QTNETWORK)
        add_definitions(-DBUILD_WITH_QTNETWORK)
        set(QT_NETWORK_COMPONENT Network)
        set(KDE_NETWORK_COMPONENT)
        set(KDE_NETWORK_LIBS)
    else()
        set(QT_NETWORK_COMPONENT)
        set(KDE_NETWORK_COMPONENT KIO)
        set(KDE_NETWORK_LIBS KF5::KIOCore KF5::KIOWidgets)
    endif()
    set(QT_NETWORK_LIB ${QT_USE_LIBSPREFIX}${QT_NETWORK_COMPONENT})

    find_package(Qt5 REQUIRED COMPONENTS
        Core
        ${QT_NETWORK_COMPONENT}
        Test
        ${QT_BROWSER_COMPONENT}
        Qml
    )

    if(BUILD_APPLETS)
        set(PLASMA_COMPONENT Package Plasma)
    endif()

    # search packages used by KDE
    find_package(KF5 REQUIRED COMPONENTS
        Config
        CoreAddons
        Completion
        I18n
        ${PLASMA_COMPONENT}
        NewStuff
        ${KDE_NETWORK_COMPONENT}
        IconThemes
        TextWidgets
        XmlGui
        OPTIONAL_COMPONENTS ${OPT_KF5_COMPONENTS}
    )

    macro(ecm_add_executable)
        add_executable(${ARGN})
    endmacro(ecm_add_executable)
    if(CMAKE_COMPILER_IS_GNUCC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
    endif()
endif()

set(TARGET_SUFFIX ${PC_TARGET_SUFFIX})
add_definitions(-DTARGET_SUFFIX=\"${TARGET_SUFFIX}\")

# figure out which multi-precision library to use
# MPIR is preferred over GMP
find_package(MPIR)
if(MPIR_FOUND)
    set(MP_INCLUDE_DIR ${MPIR_INCLUDE_DIR})
    set(MP_LIBRARIES ${MPIR_LIBRARIES})
    set(MP_HEADER mpirxx.h)
    set(MP_CMAKE_MODULE "MPIR")
    set(PC_LIB mpir)
else()
    find_package(GMP REQUIRED)
    set(MP_INCLUDE_DIR ${GMP_INCLUDE_DIR})
    set(MP_LIBRARIES ${GMP_LIBRARIES})
    set(MP_HEADER gmpxx.h)
    set(MP_CMAKE_MODULE "GMP")
    set(PC_LIB gmp)
endif()

include_directories(${MP_INCLUDE_DIR})

# check for Doxygen (for API documentation)
find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(APIDOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/apidocs)

  make_directory("${APIDOC_DIR}")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/alkimia.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/alkimia.doxygen IMMEDIATE)

  add_custom_target(apidoc "${DOXYGEN}" "${CMAKE_CURRENT_BINARY_DIR}/alkimia.doxygen")
endif(DOXYGEN_FOUND)

set(CMAKECONFIG_INSTALL_DIR "${CMAKECONFIG_INSTALL_PREFIX}/LibAlkimia${ALKIMIA_PATH_SUFFIX}-${alkimia_VERSION_MAJOR}.${alkimia_VERSION_MINOR}")

feature_summary(WHAT ALL)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

add_definitions(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
    ${MP_INCLUDE_DIR}
)

add_subdirectory(src)
add_subdirectory(qml)
if(BUILD_APPLETS)
    if(BUILD_QT4)
        add_subdirectory(plasma/applets/onlinequote)
    else()
        add_subdirectory(plasma/applets/ForeignCurrencies)
    endif()
endif()
if (KDE4_BUILD_TESTS OR BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(tests)
endif()
if (BUILD_TOOLS)
    add_subdirectory(tools)
endif()

ki18n_install(po)

=== autotests/CMakeLists.txt ===
include(ECMAddTests)
set(TEST_LIB
    alkimia
    alkimia-internal
    ${QT_USE_LIBSPREFIX}Test
    ${QT_USE_LIBSPREFIX}Core
    ${QT_USE_LIBSPREFIX}DBus
    ${MP_LIBRARIES}
)

if(BUILD_QT4)
    list(APPEND TEST_LIB ${KDE4_KDECORE_LIBS})
endif()

ecm_add_tests(
    alkonlinequotesourcetest.cpp
    alkvaluetest.cpp
    alkquoteitemtest.cpp
    alkcompanytest.cpp
    alkexceptiontest.cpp
    LINK_LIBRARIES
    alkimia ${TEST_LIB}
)

ecm_add_test(
    alkonlinequotetest.cpp
    ../src/alkquotereceiver.cpp
    LINK_LIBRARIES ${TEST_LIB}
    TEST_NAME alkonlinequotestest
)

ecm_add_test(
    alkdateformattest.cpp
    LINK_LIBRARIES ${TEST_LIB}
    TEST_NAME alkdateformattest
)

#
# cmake install test
#
set(TEMP_INSTALL_DIR ${CMAKE_BINARY_DIR}/tmp)

if(CMAKE_CROSSCOMPILING)
    if(NOT TARGET_SYSROOT)
        execute_process(
            COMMAND ${CMAKE_C_COMPILER} --print-sysroot
            OUTPUT_VARIABLE TARGET_SYSROOT
            ERROR_VARIABLE ERROR
            RESULT_VARIABLE RESULT
        )
        if(RESULT)
            set(ENABLE_CLIENT_PACKAGE_TEST 0)
            message(WARNING "disabled client package build, because sysroot could not be fetched from compiler - error is ${ERROR_VARIABLE}")
        endif()
        string(REPLACE "\n" "/${TARGET_PREFIX}" TARGET_SYSROOT "${TARGET_SYSROOT}")
    endif()
endif()

if(ENABLE_CLIENT_PACKAGE_TEST)
    # clean local install directories used by client build/install test
    add_test(
        NAME test-install-local-clean
        COMMAND ${CMAKE_COMMAND} -E remove_directory ${TEMP_INSTALL_DIR}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

    # install dbus in local directoy for client build/install test
    add_test(
        NAME test-install-local
        COMMAND ${CMAKE_MAKE_PROGRAM} install DESTDIR=${TEMP_INSTALL_DIR}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

    # build/install a client package using dbus cmake package support from this build
    add_test(
        NAME test-install-build-client-package
        COMMAND ${CMAKE_CTEST_COMMAND}
            --build-and-test
            ${CMAKE_CURRENT_SOURCE_DIR}/client-package
            ${CMAKE_CURRENT_BINARY_DIR}/client-package
            --build-config "${CMAKE_BUILD_TYPE}"
            --build-generator ${CMAKE_GENERATOR}
            --build-makeprogram ${CMAKE_MAKE_PROGRAM}
            --build-target install
            --build-options
                #--trace-expand
                -DALKIMIA_PATH_SUFFIX=${ALKIMIA_PATH_SUFFIX}
                -DLibAlkimia${ALKIMIA_PATH_SUFFIX}_DIR=${TEMP_INSTALL_DIR}${CMAKE_INSTALL_PREFIX}/${CMAKECONFIG_INSTALL_DIR}
                -DCHECK_VERSION=${PROJECT_VERSION}
                -DCMAKE_CROSSCOMPILING=${CMAKE_CROSSCOMPILING}
                -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}
                -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}
                -DCMAKE_INSTALL_PREFIX:PATH=${TEMP_INSTALL_DIR}${CMAKE_INSTALL_PREFIX}
                -DCMAKE_FIND_ROOT_PATH=${TARGET_SYSROOT};${TEMP_INSTALL_DIR}${CMAKE_INSTALL_PREFIX}
                -DCMAKE_FIND_ROOT_PATH_MODE_PROGRAM=NEVER
                -DCMAKE_FIND_ROOT_PATH_MODE_LIBRARY=ONLY
                -DCMAKE_FIND_ROOT_PATH_MODE_INCLUDE=ONLY
                -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
                -DCMAKE_SYSTEM_PROCESSOR=${CMAKE_SYSTEM_PROCESSOR}
        )

    set_property(TEST test-install-build-client-package APPEND PROPERTY DEPENDS test-install-local-clean test-install-local)
endif()

=== qml/CMakeLists.txt ===
if(BUILD_QT4)
    set(LIBS ${QT_USE_LIBSPREFIX}Declarative)
    set(QML_INSTALL_DIR ${LIB_INSTALL_DIR}/qt4/plugins/imports)
else()
    set(LIBS ${QT_USE_LIBSPREFIX}Qml)
    set_package_properties(Qt5Qml PROPERTIES  URL "git://gitorious.org/qt/qtdeclarative.git"
        DESCRIPTION "QML support for Alkimia"
        TYPE OPTIONAL
        PURPOSE "Allows to use Alkimiain QML code"
    )
    if(NOT Qt5Qml_FOUND)
        message(STATUS "Qt5Qml not found, qml imports will not be built.")
        return()
    endif()
endif()

set(IMPORTS_DIR ${CMAKE_BINARY_DIR}/bin/org/kde/alkimia)
if(WIN32)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${IMPORTS_DIR})
else()
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${IMPORTS_DIR})
endif()

configure_file(qmldir ${IMPORTS_DIR}/qmldir)
add_library(qmlalkimia qmlalkimiaplugin.cpp)
target_link_libraries(qmlalkimia ${LIBS} alkimia)

install(TARGETS qmlalkimia
    RUNTIME DESTINATION ${QML_INSTALL_DIR}/org/kde/alkimia
    LIBRARY DESTINATION ${QML_INSTALL_DIR}/org/kde/alkimia)
install(FILES qmldir DESTINATION ${QML_INSTALL_DIR}/org/kde/alkimia)

# run qml file with

=== src/CMakeLists.txt ===
include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
)

########### target alkimia-internal ###########

set(alkimia_INTERNAL_SRCS
    alkdateformat.cpp
    alkexception.cpp
    alkonlinequoteprocess.cpp
    alkquoteitem.cpp
    alkquotereceiver.cpp
)

set(alkimia_INTERNAL_HEADERS
    alkdateformat.h
    alkexception.h
    alkonlinequoteprocess.h
    alkquoteitem.h
    alkquotereceiver.h
)

set(alkimia_INTERNAL_UI
)

ki18n_wrap_ui(alkimia_INTERNAL_SRCS ${alkimia_INTERNAL_UI} )
add_library(alkimia-internal STATIC ${alkimia_INTERNAL_SRCS} ${alkimia_INTERNAL_HEADERS})
if(NOT BUILD_QT4)
    set (ALKIMIA_INTERNAL_LIBS
        PRIVATE
        KF5::CoreAddons
        KF5::NewStuff
    )
endif()
target_link_libraries(alkimia-internal PUBLIC ${QT_USE_LIBSPREFIX}Core ${ALKIMIA_INTERNAL_LIBS})
kde_target_enable_exceptions(alkimia-internal PUBLIC)

########### target alkimia ###########

set(ALKIMIA_LIB_VERSION ${alkimia_VERSION})
set(ALKIMIA_LIB_SOVERSION "${alkimia_VERSION_MAJOR}")

set(alkimia_LIB_SRCS
    alkcompany.cpp
    alkonlinequote.cpp
    alkonlinequotesource.cpp
    alkonlinequotesprofile.cpp
    alkonlinequotesprofilemanager.cpp
    alkonlinequoteswidget.cpp
    alkvalue.cpp
    alkwebpage.cpp
)

set(alkimia_LIB_HEADERS
    alkcompany.h
    alkonlinequote.h
    alkonlinequotesource.h
    alkonlinequotesprofile.h
    alkonlinequotesprofilemanager.h
    alkonlinequoteswidget.h
    alkwebpage.h
)

set(alkimia_LIB_PRIVATE_HEADERS
    alkpushbutton.h
)

if(ENABLE_FINANCEQUOTE)
    list(APPEND alkimia_LIB_SRCS alkfinancequoteprocess.cpp)
    list(APPEND alkimia_LIB_HEADERS alkfinancequoteprocess.h)
endif()

set(alkimia_UI
    alkonlinequoteswidget.ui
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/alkversion.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/alkimia/alkversion.h
    IMMEDIATE
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/alkvalue.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/alkimia/alkvalue.h
    IMMEDIATE
)

foreach(header ${alkimia_LIB_HEADERS})
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/${header}
        ${CMAKE_CURRENT_BINARY_DIR}/alkimia/${header}
        COPYONLY
    )
endforeach()

add_definitions(-DKNSRC_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

ki18n_wrap_ui(alkimia_LIB_SRCS ${alkimia_UI} )
add_library(alkimia ${alkimia_LIB_SRCS} ${alkimia_INTERNAL_SRCS} ${alkimia_LIB_HEADERS} ${alkimia_LIB_PRIVATE_HEADERS})

kde_target_enable_exceptions(alkimia PUBLIC)
if(BUILD_QT4)
    set(ALKIMIA_LIBS
        PRIVATE
        ${QT_NETWORK_LIB}
        ${KDE4_KDECORE_LIBS}
        ${KDE4_KDEUI_LIBS}
        ${KDE4_KNEWSTUFF3_LIBS}
        ${KDE_NETWORK_LIBS}
    )
else()
    set(ALKIMIA_LIBS
        PRIVATE
        ${QT5_OPTIONAL_COMPONENTS}
        KF5::Completion
        KF5::I18n
        ${KDE_NETWORK_LIBS}
        KF5::NewStuff
        KF5::IconThemes
        KF5::TextWidgets
    )
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"alkimia\")

target_link_libraries(alkimia
    PRIVATE
    alkimia-internal
    ${QT_USE_LIBSPREFIX}Core
    ${ALKIMIA_LIBS}
    ${QT_USE_LIBSPREFIX}DBus
    PUBLIC
    ${MP_LIBRARIES}
    ${QT_BROWSER_LIB}
)

if(NOT BUILD_QT4 AND MSVC AND BUILD_WITH_WEBKIT)
    message(WARNING "Applying fix for broken Qt WebKit package (see https://phabricator.kde.org/T10146 for details)")
    target_link_libraries(alkimia
        PRIVATE
        ${QT_USE_LIBSPREFIX}Test
    )
endif()

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/alkimia
    DESTINATION ${INCLUDE_INSTALL_DIR}/alkimia/${ALKIMIA_INCLUDE_SUFFIX}
    COMPONENT Devel
)

generate_export_header(alkimia BASE_NAME alk EXPORT_FILE_NAME alkimia/alk_export.h)

if(BUILD_SHARED_LIBS)
    if(WIN32)
        set_target_properties(alkimia PROPERTIES SUFFIX "-${ALKIMIA_LIB_SOVERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    else()
        set_target_properties(alkimia PROPERTIES VERSION ${ALKIMIA_LIB_VERSION} SOVERSION ${ALKIMIA_LIB_SOVERSION})
    endif()
endif()
set_target_properties(alkimia PROPERTIES OUTPUT_NAME alkimia${ALKIMIA_LIB_SUFFIX})
set(INCLUDE_INSTALL_DIR include/alkimia/${ALKIMIA_INCLUDE_SUFFIX})

if(BUILD_SHARED_LIBS)
    set(alkimia_export_targets alkimia)
else()
    set(alkimia_export_targets alkimia alkimia-internal)
endif()

install(TARGETS ${alkimia_export_targets}
    EXPORT  alkimiaTargets
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

if(BUILD_QT4)
    if(WIN32)
        set(KNSRC_INSTALL_DIR ${SHARE_INSTALL_DIR}/config)
    else()
        set(KNSRC_INSTALL_DIR ${SHARE_INSTALL_DIR}/kde4/config)
    endif()
    set(APPDATA_INSTALL_DIR ${SHARE_INSTALL_DIR}/kde4/apps)
    set(FQ_LOCAL_INSTALL_PATH ${CMAKE_BINARY_DIR}/share/apps/alkimia${ALKIMIA_PATH_SUFFIX}/misc)
else()
    if(KF5NewStuff_VERSION VERSION_GREATER "5.56.0")
        set(KNSRC_INSTALL_DIR ${KDE_INSTALL_KNSRCDIR})
    else()
        set(KNSRC_INSTALL_DIR ${CONFIG_INSTALL_DIR})
    endif()
    set(APPDATA_INSTALL_DIR ${SHARE_INSTALL_DIR})
    set(FQ_LOCAL_INSTALL_PATH ${CMAKE_BINARY_DIR}/share/alkimia${ALKIMIA_PATH_SUFFIX}/misc)
endif()

install(FILES
    alkimia-quotes.knsrc
    kmymoney-quotes.knsrc
    skrooge-quotes.knsrc
    DESTINATION ${KNSRC_INSTALL_DIR}
)

# install perl script in expected location of build dir
# KDE4: set KDEHOME to build dir
# KF5: ???
if(ENABLE_FINANCEQUOTE)
    make_directory(${FQ_LOCAL_INSTALL_PATH})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/financequote.pl ${FQ_LOCAL_INSTALL_PATH}/financequote.pl IMMEDIATE COPYONLY)
    install(PROGRAMS financequote.pl
      DESTINATION ${APPDATA_INSTALL_DIR}/alkimia${ALKIMIA_PATH_SUFFIX}/misc
    )
endif()

if (NOT WIN32)
   configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libalkimia.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libalkimia${ALKIMIA_PATH_SUFFIX}.pc IMMEDIATE @ONLY)
endif(NOT WIN32)

########### create package configuration file ###########

# create a Config.cmake and a ConfigVersion.cmake file and install them
ecm_setup_version(${alkimia_VERSION} VARIABLE_PREFIX ALKIMIA
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibAlkimia${ALKIMIA_PATH_SUFFIX}ConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/LibAlkimiaConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/LibAlkimia${ALKIMIA_PATH_SUFFIX}Config.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS INCLUDE_INSTALL_DIR
)

########### install files ###############

export(TARGETS ${alkimia_export_targets}
    FILE "${CMAKE_CURRENT_BINARY_DIR}/LibAlkimia${ALKIMIA_PATH_SUFFIX}Targets.cmake"
    NAMESPACE Alkimia::
)

install(EXPORT alkimiaTargets
    FILE LibAlkimia${ALKIMIA_PATH_SUFFIX}Targets.cmake
    NAMESPACE Alkimia::
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/LibAlkimia${ALKIMIA_PATH_SUFFIX}Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/LibAlkimia${ALKIMIA_PATH_SUFFIX}ConfigVersion.cmake"
    "../cmake/modules/Find${MP_CMAKE_MODULE}.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
)

if (NOT WIN32)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libalkimia${ALKIMIA_PATH_SUFFIX}.pc
        DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
endif(NOT WIN32)

########### documentation ###################

if(DOXYGEN_FOUND)
    set(APIDOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/apidocs)

    make_directory(${APIDOC_DIR})

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libalkimia.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/libalkimia.doxygen IMMEDIATE)

    add_custom_target(libalkimia_apidoc ${DOXYGEN} ${CMAKE_CURRENT_BINARY_DIR}/libalkimia.doxygen)
endif(DOXYGEN_FOUND)

=== autotests/client-package/CMakeLists.txt ===
#SPDX-License-Identifier: BSD-2-Clause
#SPDX-FileCopyrightText: 2023 Ralf Habacker ralf.habacker @freenet.de

cmake_minimum_required(VERSION 3.16.0)

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0074 NEW)
endif()

project(alkimiatest)
find_package(LibAlkimia${ALKIMIA_PATH_SUFFIX} CONFIG)

if(NOT LibAlkimia${ALKIMIA_PATH_SUFFIX}_VERSION OR NOT CHECK_VERSION OR NOT LibAlkimia${ALKIMIA_PATH_SUFFIX}_VERSION VERSION_EQUAL CHECK_VERSION)
    message(FATAL_ERROR "version mismatch actual '${LibAlkimia${ALKIMIA_PATH_SUFFIX}_VERSION}' expected '${CHECK_VERSION}'")
endif()

add_executable(mytest test.cpp)
target_link_libraries(mytest Alkimia::alkimia)
install(TARGETS mytest DESTINATION bin)

=== tools/onlinequoteseditor/CMakeLists.txt ===
add_subdirectory(icons)

include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
)

set(SOURCES
    applicationsettings.cpp
    main.cpp
    mainwindow.cpp
)

set(HEADERS
    applicationsettings.h
    mainwindow.h
)

set(UI
    mainwindow.ui
)

ki18n_wrap_ui(SOURCES ${UI} )

ecm_add_app_icon(SOURCES
    ICONS
    icons/16-apps-onlinequoteseditor5.png
    icons/22-apps-onlinequoteseditor5.png
    icons/32-apps-onlinequoteseditor5.png
    icons/48-apps-onlinequoteseditor5.png
    icons/64-apps-onlinequoteseditor5.png
    icons/128-apps-onlinequoteseditor5.png
)

ecm_add_executable(onlinequoteseditor ${SOURCES} ${HEADERS})
if(BUILD_QT4)
    set(LIBS
        ${KDE4_KDECORE_LIBS}
        ${KDE4_KDEUI_LIBS}
        ${QT_USE_LIBSPREFIX}Core
        ${QT_USE_LIBSPREFIX}Network
    )
else()
    set(LIBS
        Qt5::Widgets
        Qt5::Network
        ${QT_BROWSER_LIB}
        KF5::CoreAddons
        KF5::I18n
        KF5::XmlGui
    )
    add_definitions(-DTRANSLATION_DOMAIN=\"onlinequoteseditor\")
endif()

target_link_libraries(onlinequoteseditor
    alkimia
    alkimia-internal
    ${LIBS}
)
set_target_properties(onlinequoteseditor PROPERTIES OUTPUT_NAME onlinequoteseditor${TARGET_SUFFIX})

install(TARGETS onlinequoteseditor ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

configure_file(org.kde.onlinequoteseditor.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.onlinequoteseditor${TARGET_SUFFIX}.desktop)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.onlinequoteseditor${TARGET_SUFFIX}.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

configure_file(org.kde.onlinequoteseditor.appdata.xml.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.onlinequoteseditor${TARGET_SUFFIX}.appdata.xml)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.onlinequoteseditor${TARGET_SUFFIX}.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

if(APPSTREAMCLI)
    add_test(
        NAME appstreamtest
        COMMAND ${APPSTREAMCLI} validate ${CMAKE_CURRENT_BINARY_DIR}/org.kde.onlinequoteseditor${TARGET_SUFFIX}.appdata.xml
    )
else()
    message(STATUS "Could not set up the appstream test. appstreamcli is missing.")
endif()

=== tools/onlinequoteseditor/icons/CMakeLists.txt ===
ecm_install_icons(
    ICONS 16-apps-onlinequoteseditor5.png
          22-apps-onlinequoteseditor5.png
          32-apps-onlinequoteseditor5.png
          48-apps-onlinequoteseditor5.png
          64-apps-onlinequoteseditor5.png
          128-apps-onlinequoteseditor5.png
          sc-apps-onlinequoteseditor5.svgz
    THEME hicolor
    DESTINATION ${ICON_INSTALL_DIR}
)

=== debian/changelog ===
alkimia (8.1.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop unnecessary Build-Depends: libqt5webkit5-dev. (Closes: #1098334)

 -- Bastian Germann <bage@debian.org>  Wed, 19 Feb 2025 12:20:52 +0100

alkimia (8.1.2-2) unstable; urgency=medium

  * Team upload.
  * Update symbols file from the logs of buildds.
  * Drop also the not useful README files in installed data files
    - ship the README for plasma-widget-foreigncurrencies from the sources,
      instead of relying on it being installed
  * Switch the cmake parameter -DCMAKE_DISABLE_FIND_PACKAGE_MPIR=OFF to
    -DCMAKE_DISABLE_FIND_PACKAGE_MPIR=ON to actually disable the search of MPIR;
    GMP is wanted instead.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Oct 2023 08:00:21 +0200

alkimia (8.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update standards version to 4.6.2, no changes needed.
  * Update the upstream GPG signing key.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16.0
  * Drop LICENSE files after the installation to debian/tmp; this way there is
    no need for extra steps to avoid them in install files:
    - simplify debian/plasma-widget-foreigncurrencies.install, shipping the
      whole directory of the plasmoid
    - drop debian/not-installed, no more needed

 -- Pino Toscano <pino@debian.org>  Wed, 06 Sep 2023 00:58:50 +0200

=== debian/control ===
Source: alkimia
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake (>= 3.16.0~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 0.0.11~),
               libgmp-dev,
               libkf5completion-dev,
               libkf5config-dev,
               libkf5coreaddons-dev,
               libkf5i18n-dev,
               libkf5iconthemes-dev,
               libkf5kio-dev,
               libkf5newstuff-dev,
               libkf5package-dev,
               libkf5plasma-dev,
               libkf5textwidgets-dev,
               libkf5xmlgui-dev,
               pkg-config,
               pkg-kde-tools (>= 0.5.0),
               qtbase5-dev,
               qtdeclarative5-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/office/alkimia
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/alkimia
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/alkimia.git
Rules-Requires-Root: no

Package: alkimia-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Financial library - binaries
 Libalkimia is a library with common classes and functionality used by
 finance applications for KDE. Currently it supports a common
 class to represent monetary values with arbitrary precision.
 .
 Commandline binaries for the library.

Package: alkimia-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Financial library - data files
 Libalkimia is a library with common classes and functionality used by
 finance applications for KDE. Currently it supports a common
 class to represent monetary values with arbitrary precision.
 .
 Support files for the library.

Package: libalkimia5-8
Architecture: any
Multi-Arch: same
Depends: alkimia-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: alkimia-bin
Description: Financial library common classes for KDE
 Libalkimia is a library with common classes and functionality used by
 finance applications for KDE. Currently it supports a common
 class to represent monetary values with arbitrary precision.

Package: libalkimia5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libalkimia5-8 (= ${binary:Version}),
         libgmp-dev,
         qtbase5-dev,
         ${misc:Depends}
Description: Financial library - Development files
 Libalkimia is a library with common classes and functionality used by
 finance applications for KDE. Currently it supports a common
 class to represent monetary values with arbitrary precision.
 .
 This package contains development files needed for Libalkimia.

Package: plasma-widget-foreigncurrencies
Architecture: all
Multi-Arch: foreign
Depends: plasma-desktop,
         qml-module-org-kde-alkimia (>= ${source:Version}),
         qml-module-qtquick-controls,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         ${misc:Depends}
Description: Financial library - Currency Plasmoid
 Libalkimia is a library with common classes and functionality used by
 finance applications for KDE. Currently it supports a common
 class to represent monetary values with arbitrary precision.
 .
 Plasma Widget for foreign currencies.

Package: qml-module-org-kde-alkimia
Architecture: any
Multi-Arch: same
Depends: libalkimia5-8 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Financial library - QML Module
 Libalkimia is a library with common classes and functionality used by
 finance applications for KDE. Currently it supports a common
 class to represent monetary values with arbitrary precision.
 .
 This package contains the files for using Alkimia with QML.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all buildinfo=+path
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_DISABLE_FIND_PACKAGE_MPIR=ON

override_dh_auto_test:
	- xvfb-run dh_auto_test --no-parallel

execute_after_dh_auto_install:
	# delete extra license files
	find debian/tmp -name LICENSE -print -delete
	# delete extra README files
	find debian/tmp -name README -print -delete
